'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _symbol = require('babel-runtime/core-js/symbol');

var _symbol2 = _interopRequireDefault(_symbol);

var _mergeConfigs = require('../merge-configs');

var _mergeConfigs2 = _interopRequireDefault(_mergeConfigs);

var _graphCrdt = require('graph-crdt');

var _context3 = require('./context');

var _context4 = _interopRequireDefault(_context3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var settings = (0, _symbol2.default)('database configuration');
var data = (0, _symbol2.default)('database graph');

/**
 * Plugin manager for graph-crdt.
 * @class Database
 */

var Database = function () {

  /**
   * Instantiates a new graph database.
   * @param  {Object} config - A database configuration object.
   */
  function Database(config) {
    (0, _classCallCheck3.default)(this, Database);

    this[settings] = config;
    this[data] = new _graphCrdt.Graph();
  }

  /**
   * Merges a node into the graph.
   * @param  {String} uid - The unique ID of the node.
   * @param  {Object} value - The fields to add/update.
   * @return {Context} - Resolves to the context written.
   */


  (0, _createClass3.default)(Database, [{
    key: 'write',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(uid, value) {
        var graph, node;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                graph = this[data];
                node = new _context4.default(this, { uid: uid });


                node.merge(value);
                graph.merge((0, _defineProperty3.default)({}, node, node));

                return _context.abrupt('return', node);

              case 5:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function write(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return write;
    }()

    /**
     * Read a context from the database.
     * @param  {String} uid - The node's unique ID.
     * @return {Context|undefined} - Resolves to the node.
     */

  }, {
    key: 'read',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(uid) {
        var graph;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                graph = this[data];
                return _context2.abrupt('return', graph.read(uid));

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function read(_x3) {
        return _ref2.apply(this, arguments);
      }

      return read;
    }()
  }]);
  return Database;
}();

/**
 * Creates a new instance of `Database` with or without `new`.
 * @param  {...Object} configs - Plugins and configurations for the database.
 * @return {Database} - A new database instance.
 */


function database() {
  for (var _len = arguments.length, configs = Array(_len), _key = 0; _key < _len; _key++) {
    configs[_key] = arguments[_key];
  }

  var config = (0, _mergeConfigs2.default)(configs);

  return new Database(config);
}

database.configuration = settings;
database.graph = data;

exports.default = database;